package taghttp

import (
	"net/http"

	authmiddleware "legalgo-BE-go/internal/api/http/middleware/auth"
	tagdomain "legalgo-BE-go/internal/domain/tag"
	tagsvc "legalgo-BE-go/internal/services/tag"
	"legalgo-BE-go/internal/utilities/response"
	"legalgo-BE-go/internal/utilities/utils"

	"github.com/go-chi/chi/v5"
	"github.com/go-playground/validator/v10"
)

func Create(
	router chi.Router,
	validate *validator.Validate,
	tagSvc tagsvc.Tag,
) {
	router.
		With(authmiddleware.Authorize()).
		Post("/tag/create", func(w http.ResponseWriter, r *http.Request) {
			ctx := r.Context()

			var spec tagdomain.TagReq

			if err := utils.UnmarshalBody(r, &spec); err != nil {
				response.ResponseWithErrorCode(
					ctx,
					w,
					err,
					response.ErrBadRequest.Code,
					response.ErrBadRequest.HttpCode,
					"failed to unmarshal request",
				)
				return
			}

			if err := validate.Struct(spec); err != nil {
				response.ResponseWithErrorCode(
					ctx,
					w,
					err,
					response.ErrBadRequest.Code,
					response.ErrBadRequest.HttpCode,
					err.(validator.ValidationErrors).Error(),
				)
				return
			}

			if err := tagSvc.Create(spec); err != nil {
				response.ResponseWithErrorCode(
					ctx,
					w,
					err,
					response.ErrCreateEntity.Code,
					response.ErrCreateEntity.HttpCode,
					err.Error(),
				)
				return
			}

			response.RespondJsonSuccess(ctx, w, struct {
				Message string
			}{
				Message: "tag created successfully.",
			})
		})
}
